//+------------------------------------------------------------------+
//|                                                 Dynamic zone CFP |
//|                                                                  |
//| original CFP by SemSemFX@rambler.ru                              |
//| http://onix-trade.net/forum/index.php?showtopic=107              |
//|                                                                  |
//| rewritten by mladen                                              |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  DimGray
#property indicator_width1  2
#property indicator_style4  STYLE_DOT

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern string TimeFrame               = "Current time frame";
extern string ForSymbol               = "";
extern string Prefix                  = "";
extern string Suffix                  = "";
extern int    MaMethod                = MODE_SMMA;
extern int    FastMaPeriod            = 3;
extern int    SlowMaPeriod            = 5;
extern int    Price                   = 6;
extern bool   USD                     = true;
extern bool   EUR                     = true;
extern bool   GBP                     = true;
extern bool   CHF                     = true;
extern bool   JPY                     = true;
extern bool   AUD                     = true;
extern bool   CAD                     = true;
extern bool   NZD                     = true;
extern int    DzLookBackBars          = 70;
extern double DzStartBuyProbability   = 0.16;
extern double DzStartSellProbability  = 0.16;
extern bool   Inverted                = false;
extern bool   arrowsVisible           = false;
extern bool   arrowsOnZeroLineCross   = true;
extern bool   arrowsOnUpperZoneCross  = true;
extern bool   arrowsOnLowerZoneCross  = true;
extern bool   arrowsOnCross           = true;
extern bool   arrowsOnRevert          = true;
extern string arrowsUniqueID          = "DzCfpArrows1";
extern color  arrowsZeroUpColor       = DeepSkyBlue;
extern color  arrowsZeroDnColor       = PaleVioletRed;
extern color  arrowsUpperUpColor      = DeepSkyBlue;
extern color  arrowsUpperDnColor      = PaleVioletRed;
extern color  arrowsLowerUpColor      = DeepSkyBlue;
extern color  arrowsLowerDnColor      = PaleVioletRed;
extern int    arrowsUpCode            = 241;
extern int    arrowsDownCode          = 242;
extern bool   alertsOn                = false;
extern bool   alertsOnZeroLine        = true;
extern bool   alertsOnUpperZone       = true;
extern bool   alertsOnLowerZone       = true;
extern bool   alertsOnCross           = true;
extern bool   alertsOnRevert          = false;
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = false;
extern bool   alertsEmail             = false;

extern bool   Interpolate = true;


//
//
//
//
//

double OUT[];
double cen[];
double bli[];
double sli[];

//
//
//
//
//

string symbols[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,OUT); SetIndexLabel(0, Symbol()); 
   SetIndexBuffer(1,bli);
   SetIndexBuffer(2,sli);
   SetIndexBuffer(3,cen);
   
   //
   //
   //
   //
   //

      if (StringTrimLeft(StringTrimRight(ForSymbol))=="") ForSymbol = Symbol();
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);

            if (EUR) addSymbol("EURUSD");
            if (GBP) addSymbol("GBPUSD");
            if (AUD) addSymbol("AUDUSD");
            if (NZD) addSymbol("NZDUSD");
            if (CAD) addSymbol("USDCAD");
            if (CHF) addSymbol("USDCHF");
            if (JPY) addSymbol("USDJPY");
      
      calculateValue = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame      = stringToTimeFrame(TimeFrame);

   //
   //
   //
   //
   //         
      
   IndicatorShortName(ForSymbol+" "+timeFrameToString(timeFrame)+" CFP "+Symbol());      
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = arrowsUniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double trends[][3];

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { OUT[0] = limit; return(0); }
         if (ArrayRange(trends,0) != Bars) ArrayResize(trends,Bars);

   //
   //
   //
   //
   //

   double multiplier=1; if (Inverted) multiplier = -1;
   if (calculateValue || (timeFrame==Period() && ForSymbol==Symbol()))
   {
      for (int k=0; k<ArraySize(symbols); k++) limit = getLimit(limit,symbols[k]);
      
      //
      //
      //
      //
      //
      
      for(i=0; i<limit; i++)
      {
         double EURUSD_Fast=0; double EURUSD_Slow=0; if (!getMaValues(EUR,"EURUSD",EURUSD_Fast,EURUSD_Slow,i)) break;
         double GBPUSD_Fast=0; double GBPUSD_Slow=0; if (!getMaValues(GBP,"GBPUSD",GBPUSD_Fast,GBPUSD_Slow,i)) break;
         double AUDUSD_Fast=0; double AUDUSD_Slow=0; if (!getMaValues(AUD,"AUDUSD",AUDUSD_Fast,AUDUSD_Slow,i)) break;
         double NZDUSD_Fast=0; double NZDUSD_Slow=0; if (!getMaValues(NZD,"NZDUSD",NZDUSD_Fast,NZDUSD_Slow,i)) break;
         double USDCAD_Fast=0; double USDCAD_Slow=0; if (!getMaValues(CAD,"USDCAD",USDCAD_Fast,USDCAD_Slow,i)) break;
         double USDCHF_Fast=0; double USDCHF_Slow=0; if (!getMaValues(CHF,"USDCHF",USDCHF_Fast,USDCHF_Slow,i)) break;
         double USDJPY_Fast=0; double USDJPY_Slow=0; if (!getMaValues(JPY,"USDJPY",USDJPY_Fast,USDJPY_Slow,i)) break;

         //
         //
         //
         //
         //
       
         double arrUSD = 0; 
         if (USD) { if (EUR) arrUSD += EURUSD_Slow / EURUSD_Fast - 1;
                    if (GBP) arrUSD += GBPUSD_Slow / GBPUSD_Fast - 1;
                    if (AUD) arrUSD += AUDUSD_Slow / AUDUSD_Fast - 1;
                    if (NZD) arrUSD += NZDUSD_Slow / NZDUSD_Fast - 1;
                    if (CHF) arrUSD += USDCHF_Fast / USDCHF_Slow - 1;
                    if (CAD) arrUSD += USDCAD_Fast / USDCAD_Slow - 1;
                    if (JPY) arrUSD += USDJPY_Fast / USDJPY_Slow - 1; }
                 
         double arrEUR = 0;
         if (EUR) { if (USD)  arrEUR +=  EURUSD_Fast / EURUSD_Slow - 1;
                    if (GBP)  arrEUR += (EURUSD_Fast / GBPUSD_Fast) / (EURUSD_Slow / GBPUSD_Slow) - 1;
                    if (AUD)  arrEUR += (EURUSD_Fast / AUDUSD_Fast) / (EURUSD_Slow / AUDUSD_Slow) - 1;
                    if (NZD)  arrEUR += (EURUSD_Fast / NZDUSD_Fast) / (EURUSD_Slow / NZDUSD_Slow) - 1;
                    if (CHF)  arrEUR += (EURUSD_Fast * USDCHF_Fast) / (EURUSD_Slow * USDCHF_Slow) - 1;
                    if (CAD)  arrEUR += (EURUSD_Fast * USDCAD_Fast) / (EURUSD_Slow * USDCAD_Slow) - 1;
                    if (JPY)  arrEUR += (EURUSD_Fast * USDJPY_Fast) / (EURUSD_Slow * USDJPY_Slow) - 1; }
         
         double arrGBP = 0;
         if (GBP) { if (USD) arrGBP +=  GBPUSD_Fast / GBPUSD_Slow-1;
                    if (EUR) arrGBP += (EURUSD_Slow / GBPUSD_Slow) / (EURUSD_Fast / GBPUSD_Fast) - 1;
                    if (AUD) arrGBP += (GBPUSD_Fast / AUDUSD_Fast) / (GBPUSD_Slow / AUDUSD_Slow) - 1;
                    if (NZD) arrGBP += (GBPUSD_Fast / NZDUSD_Fast) / (GBPUSD_Slow / NZDUSD_Slow) - 1;
                    if (CHF) arrGBP += (GBPUSD_Fast * USDCHF_Fast) / (GBPUSD_Slow * USDCHF_Slow) - 1;
                    if (CAD) arrGBP += (GBPUSD_Fast * USDCAD_Fast) / (GBPUSD_Slow * USDCAD_Slow) - 1;
                    if (JPY) arrGBP += (GBPUSD_Fast * USDJPY_Fast) / (GBPUSD_Slow * USDJPY_Slow) - 1; }
       
         double arrAUD = 0;
         if (AUD) { if (USD) arrAUD +=  AUDUSD_Fast / AUDUSD_Slow - 1;
                    if (EUR) arrAUD += (EURUSD_Slow / AUDUSD_Slow) / (EURUSD_Fast / AUDUSD_Fast) - 1;
                    if (GBP) arrAUD += (GBPUSD_Slow / AUDUSD_Slow) / (GBPUSD_Fast / AUDUSD_Fast) - 1;
                    if (NZD) arrAUD += (AUDUSD_Fast / NZDUSD_Fast) / (AUDUSD_Slow / NZDUSD_Slow) - 1;
                    if (CHF) arrAUD += (AUDUSD_Fast * USDCHF_Fast) / (AUDUSD_Slow * USDCHF_Slow) - 1;
                    if (CAD) arrAUD += (AUDUSD_Fast * USDCAD_Fast) / (AUDUSD_Slow * USDCAD_Slow) - 1;
                    if (JPY) arrAUD += (AUDUSD_Fast * USDJPY_Fast) / (AUDUSD_Slow * USDJPY_Slow) - 1; }
       
         double arrNZD = 0;
         if (NZD) { if (USD) arrNZD +=  NZDUSD_Fast / NZDUSD_Slow - 1;
                    if (EUR) arrNZD += (EURUSD_Slow / NZDUSD_Slow) / (EURUSD_Fast / NZDUSD_Fast) - 1;
                    if (GBP) arrNZD += (GBPUSD_Slow / NZDUSD_Slow) / (GBPUSD_Fast / NZDUSD_Fast) - 1;
                    if (AUD) arrNZD += (AUDUSD_Slow / NZDUSD_Slow) / (AUDUSD_Fast / NZDUSD_Fast) - 1;
                    if (CHF) arrNZD += (NZDUSD_Fast * USDCHF_Fast) / (NZDUSD_Slow * USDCHF_Slow) - 1;
                    if (CAD) arrNZD += (NZDUSD_Fast * USDCAD_Fast) / (NZDUSD_Slow * USDCAD_Slow) - 1;
                    if (JPY) arrNZD += (NZDUSD_Fast * USDJPY_Fast) / (NZDUSD_Slow * USDJPY_Slow) - 1; }
       
         double arrCAD = 0;
         if (CAD) { if (USD) arrCAD +=  USDCAD_Slow / USDCAD_Fast - 1;
                    if (EUR) arrCAD += (EURUSD_Slow * USDCAD_Slow) / (EURUSD_Fast * USDCAD_Fast) - 1;
                    if (GBP) arrCAD += (GBPUSD_Slow * USDCAD_Slow) / (GBPUSD_Fast * USDCAD_Fast) - 1;
                    if (AUD) arrCAD += (AUDUSD_Slow * USDCAD_Slow) / (AUDUSD_Fast * USDCAD_Fast) - 1;
                    if (NZD) arrCAD += (NZDUSD_Slow * USDCAD_Slow) / (NZDUSD_Fast * USDCAD_Fast) - 1;
                    if (CHF) arrCAD += (USDCHF_Fast / USDCAD_Fast) / (USDCHF_Slow / USDCAD_Slow) - 1;
                    if (JPY) arrCAD += (USDJPY_Fast / USDCAD_Fast) / (USDJPY_Slow / USDCAD_Slow) - 1; }
       
         double arrCHF = 0;
         if (CHF) { if (USD) arrCHF +=  USDCHF_Slow / USDCHF_Fast - 1;
                    if (EUR) arrCHF += (EURUSD_Slow * USDCHF_Slow) / (EURUSD_Fast * USDCHF_Fast) - 1;
                    if (GBP) arrCHF += (GBPUSD_Slow * USDCHF_Slow) / (GBPUSD_Fast * USDCHF_Fast) - 1;
                    if (AUD) arrCHF += (AUDUSD_Slow * USDCHF_Slow) / (AUDUSD_Fast * USDCHF_Fast) - 1;
                    if (NZD) arrCHF += (NZDUSD_Slow * USDCHF_Slow) / (NZDUSD_Fast * USDCHF_Fast) - 1;
                    if (CAD) arrCHF += (USDCHF_Slow / USDCAD_Slow) / (USDCHF_Fast / USDCAD_Fast) - 1;
                    if (JPY) arrCHF += (USDJPY_Fast / USDCHF_Fast) / (USDJPY_Slow / USDCHF_Slow) - 1; }
       
         double arrJPY = 0;
         if (JPY) { if (USD) arrJPY +=  USDJPY_Slow / USDJPY_Fast - 1;
                    if (EUR) arrJPY += (EURUSD_Slow * USDJPY_Slow) / (EURUSD_Fast * USDJPY_Fast) - 1;
                    if (GBP) arrJPY += (GBPUSD_Slow * USDJPY_Slow) / (GBPUSD_Fast * USDJPY_Fast) - 1;
                    if (AUD) arrJPY += (AUDUSD_Slow * USDJPY_Slow) / (AUDUSD_Fast * USDJPY_Fast) - 1;
                    if (NZD) arrJPY += (NZDUSD_Slow * USDJPY_Slow) / (NZDUSD_Fast * USDJPY_Fast) - 1;
                    if (CAD) arrJPY += (USDJPY_Slow / USDCAD_Slow) / (USDJPY_Fast / USDCAD_Fast) - 1;
                    if (CHF) arrJPY += (USDJPY_Slow / USDCHF_Slow) / (USDJPY_Fast / USDCHF_Fast) - 1; }
       
         OUT[i] = 0;
            if(0 == StringFind(Symbol(), "USD", 0))  OUT[i] += arrUSD*multiplier;
            if(3 == StringFind(Symbol(), "USD", 0))  OUT[i] -= arrUSD*multiplier;
            if(0 == StringFind(Symbol(), "EUR", 0))  OUT[i] += arrEUR*multiplier;
            if(0 == StringFind(Symbol(), "GBP", 0))  OUT[i] += arrGBP*multiplier;
            if(3 == StringFind(Symbol(), "GBP", 0))  OUT[i] -= arrGBP*multiplier;
            if(0 == StringFind(Symbol(), "CHF", 0))  OUT[i] += arrCHF*multiplier;
            if(3 == StringFind(Symbol(), "CHF", 0))  OUT[i] -= arrCHF*multiplier;
            if(3 == StringFind(Symbol(), "JPY", 0))  OUT[i] -= arrJPY*multiplier;
            if(0 == StringFind(Symbol(), "CAD", 0))  OUT[i] += arrCAD*multiplier;
            if(3 == StringFind(Symbol(), "CAD", 0))  OUT[i] -= arrCAD*multiplier;
            if(0 == StringFind(Symbol(), "AUD", 0))  OUT[i] += arrAUD*multiplier;
            if(3 == StringFind(Symbol(), "AUD", 0))  OUT[i] -= arrAUD*multiplier;
            if(0 == StringFind(Symbol(), "NZD", 0))  OUT[i] += arrNZD*multiplier;
            if(3 == StringFind(Symbol(), "NZD", 0))  OUT[i] -= arrNZD*multiplier;
      }

      //
      //
      //
      //
      //
      
         if (Digits>3)
               double precision = 0.001;
         else         precision = 0.1;            
         for(r=Bars-i-1; i>=0; i--,r++)
         {
            bli[i] = dzBuyP (OUT, DzStartBuyProbability,  DzLookBackBars, Bars, i, precision);
            sli[i] = dzSellP(OUT, DzStartSellProbability, DzLookBackBars, Bars, i, precision);
            cen[i] = dzSellP(OUT, 0.5,                    DzLookBackBars, Bars, i, precision);
         //
         //
         //
         //
         //
         
            trends[r][0] = trends[r-1][0];
            trends[r][1] = trends[r-1][1];
            trends[r][2] = trends[r-1][2];

               if (OUT[i]>cen[i]) trends[r][0]= 1;
               if (OUT[i]<cen[i]) trends[r][0]=-1;
               if (OUT[i]>sli[i]) trends[r][1]= 1;
               if (OUT[i]<sli[i]) trends[r][1]=-1;
               if (OUT[i]>bli[i]) trends[r][2]= 1;
               if (OUT[i]<bli[i]) trends[r][2]=-1;

            manageArrow(i);
            
         }
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //

   for (k=0; k<ArraySize(symbols); k++) limit = getTfLimit(limit,symbols[k]);
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
         OUT[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",Prefix,Suffix,MaMethod,FastMaPeriod,SlowMaPeriod,Price,USD,EUR,GBP,CHF,JPY,AUD,CAD,NZD,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,Inverted,0,y);
         bli[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",Prefix,Suffix,MaMethod,FastMaPeriod,SlowMaPeriod,Price,USD,EUR,GBP,CHF,JPY,AUD,CAD,NZD,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,Inverted,1,y);
         sli[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",Prefix,Suffix,MaMethod,FastMaPeriod,SlowMaPeriod,Price,USD,EUR,GBP,CHF,JPY,AUD,CAD,NZD,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,Inverted,2,y);
         cen[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue","",Prefix,Suffix,MaMethod,FastMaPeriod,SlowMaPeriod,Price,USD,EUR,GBP,CHF,JPY,AUD,CAD,NZD,DzLookBackBars,DzStartBuyProbability,DzStartSellProbability,Inverted,3,y);
         trends[r][0] = trends[r-1][0];
         trends[r][1] = trends[r-1][1];
         trends[r][2] = trends[r-1][2];

            if (OUT[i]>cen[i]) trends[r][0]= 1;
            if (OUT[i]<cen[i]) trends[r][0]=-1;
            if (OUT[i]>sli[i]) trends[r][1]= 1;
            if (OUT[i]<sli[i]) trends[r][1]=-1;
            if (OUT[i]>bli[i]) trends[r][2]= 1;
            if (OUT[i]<bli[i]) trends[r][2]=-1;
            manageArrow(i);

         //
         //
         //
         //
         //
      
            if (y==iBarShift(NULL,timeFrame,Time[i-1]) || !Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int j = 1; j < n; j++)
            {
               OUT[i+j] = OUT[i] + (OUT[i+n]-OUT[i])*j/n;
               bli[i+j] = bli[i] + (bli[i+n]-bli[i])*j/n;
               sli[i+j] = sli[i] + (sli[i+n]-sli[i])*j/n;
               cen[i+j] = cen[i] + (cen[i+n]-cen[i])*j/n;
            }               
   }

   //
   //
   //
   //
   //

   manageAlerts();      
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (!calculateValue && arrowsVisible)
   {
      int r = Bars-i-1;
         deleteArrow(Time[i]);
         if (arrowsOnZeroLineCross && trends[r][0]!=trends[r-1][0])
         {
            if (arrowsOnCross  && trends[r][0] == 1) drawArrow(i,arrowsZeroUpColor,arrowsUpCode  ,false);
            if (arrowsOnCross  && trends[r][0] ==-1) drawArrow(i,arrowsZeroDnColor,arrowsDownCode,true);
         }
         if (arrowsOnUpperZoneCross && trends[r][1]!=trends[r-1][1])
         {
            if (arrowsOnCross  && trends[r][1] == 1) drawArrow(i,arrowsUpperUpColor,arrowsUpCode  ,false);
            if (arrowsOnRevert && trends[r][1] ==-1) drawArrow(i,arrowsUpperDnColor,arrowsDownCode,true);
         }
         if (arrowsOnLowerZoneCross && trends[r][2]!=trends[r-1][2])
         {
            if (arrowsOnCross  && trends[r][2] ==-1) drawArrow(i,arrowsLowerDnColor,arrowsDownCode,true);
            if (arrowsOnRevert && trends[r][2] == 1) drawArrow(i,arrowsLowerUpColor,arrowsUpCode  ,false);
         }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsUniqueID+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] -gap);
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsUniqueID+":"+time; ObjectDelete(lookFor);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int forBar = 0;
      else     forBar = 1; forBar = iBarShift(ForSymbol,0,iTime(ForSymbol,timeFrame,forBar)); int whichBar = Bars-forBar-1;
      
      //
      //
      //
      //
      //
      
      if (alertsOnZeroLine && trends[whichBar][0] != trends[whichBar-1][0])
      {
         static datetime savedTime1 = 0;
         static string   savedMess1 = "";
            if (alertsOnCross && trends[whichBar][0] == 1) doAlert(savedTime1,savedMess1,forBar,"zero line up");
            if (alertsOnCross && trends[whichBar][0] ==-1) doAlert(savedTime1,savedMess1,forBar,"zero line down");
      }         
      if (alertsOnUpperZone && trends[whichBar][1] != trends[whichBar-1][1])
      {
         static datetime savedTime2 = 0;
         static string   savedMess2 = "";
            if (alertsOnCross  && trends[whichBar][1] == 1) doAlert(savedTime2,savedMess2,forBar,"upper zone up");
            if (alertsOnRevert && trends[whichBar][1] ==-1) doAlert(savedTime2,savedMess2,forBar,"upper zone down");
      }         
      if (alertsOnLowerZone && trends[whichBar][2] != trends[whichBar-1][2])
      {
         static datetime savedTime3 = 0;
         static string   savedMess3 = "";
            if (alertsOnCross  && trends[whichBar][2] ==-1) doAlert(savedTime3,savedMess3,forBar,"lower zone down");
            if (alertsOnRevert && trends[whichBar][2] == 1) doAlert(savedTime3,savedMess3,forBar,"lower zone up");
      }         
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(ForSymbol," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DZ CFP crossed",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"DZ CFP"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void addSymbol(string symbol)
{
   ArrayResize(symbols,ArraySize(symbols)+1); symbols[ArraySize(symbols)-1] = Prefix+symbol+Suffix;
}

//
//
//
//
//

int getLimit(int limit, string symbol)
{
   if (ForSymbol!=Symbol())
          limit = MathMin(Bars-1,MathMax(iCustom(symbol,0,indicatorFileName,"returnBars",0,0),limit));
   return(limit);
}
int getTfLimit(int limit, string symbol)
{
   return(MathMin(Bars-1,MathMax((iCustom(symbol,timeFrame,indicatorFileName,"returnBars",0,0)+1)*timeFrame/Period(),limit)));
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

bool getMaValues(bool doIt, string symbol, double& fast, double& slow,int i)
{
   if (doIt)
   {
      fast = ma(Prefix+symbol+Suffix,FastMaPeriod,MaMethod,Price,i);
      slow = ma(Prefix+symbol+Suffix,SlowMaPeriod,MaMethod,Price,i);
            return(fast!=0 && slow!=0);
   }
   return(true);
}

//
//
//
//
//
  
double ma(string sym, int per, int Mode, int Price, int i)
  {
   double res = 0; int k = 1;
   switch(Period())
   {
       case 1:     res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 5;
       case 5:     res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 3;
       case 15:    res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 2;
       case 30:    res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 2;
       case 60:    res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 4;
       case 240:   res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 6;
       case 1440:  res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 4;
       case 10080: res += iMA(sym, 0, per*k, 0, Mode, Price,i); k += 4;
       case 43200: res += iMA(sym, 0, per*k, 0, Mode, Price,i);
   }
   return(res);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


